#include <stdio.h>
#include <math.h>
#define n 10000
#define bok 48.
double a8[8],b8[8];
double cx,cy,pi;
char h[72][80];
FILE *fp;
float bx[n],by[n];
float ux[n],uy[n];
float vx[n],vy[n];
int    w[n];
int nb,nu;
float scale,field;
int n1,n2;

main(int ac,char **av)
{
  int i,j,k,m;
  char f1[30],t[70],a[140];
  float x1,x2,x3,x4,x5,x6;
  double  x,y,z,r,r0=4.;
  pi=4.*atan(1.0); cx=pi/12.; cy=pi/180.;
  if(ac<2){ printf("\n\t ****** use UCAC4, check *.fit coord_sys *******\n");
            printf("\n\t Usage: chbok combin_file.fit [!]\n\n");
            exit(0);
          }
  strcpy(f1,av[1]); 
//  system("cp /vega2/rhbin/uefault.sex default.sex");
  system("cp /vega2/rhbin/default.sex .");
  system("cp /vega2/rhbin/default.nnw .");
  system("cp /vega2/rhbin/default.conv .");
  system("cp /vega2/rhbin/default.param .");
  sprintf(t,"sex %s",f1); system(t);
  fp=fopen("test.cat","r");
  nb=0;
l10:
  fgets(a,140,fp); if(feof(fp))goto l20;
  if(a[0]=='#')goto l10;
  sscanf(a,"%f%f%f",&x6,&x1,&x2);
  bx[nb]=x1; by[nb]=x2; nb++; if(nb<n-1)goto l10;
l20:
  fclose(fp);  printf("readin bertin_star: %d\n",nb);

  fp=fopen(f1,"rb");if(!fp){ printf("\n\t file not found!\n",f1); exit(0);}
  fread(h,72,80,fp); fclose(fp);
  k=indexpos(h,"A81     ",72);
  if(k==72){ printf("\nfits_file not coordinated !\n"); exit(0); }
  for(i=0;i<8;i++)sscanf(&h[k+i][10],"%le",&a8[i]);
  xytoad(a8,b8);
  k=indexpos(h,"SCALE   ",72); sscanf(&h[k][20],"%f",&scale);
  sscanf(&h[3][20],"%d",&n1); sscanf(&h[4][20],"%d",&n2);
  k=(n1>n2)?n1:n2;  field=k*scale/60.+0.5;  
  h[11][30]=h[12][30]=0;
  sprintf(a,"%s %s%6.1f",&h[11][18],&h[12][18],field);
  printf("\n%s %s scale: %7.3f\n",f1,a,scale);  

  sprintf(t,"u4 %s test.u4 2000.0 2012.0",a); system(t);
  fp=fopen("test.u4","r"); nu=0;
l30:
  fgets(a,140,fp); if(feof(fp))goto l40;
  if(a[0]=='#')goto l30;
  a[18]=a[32]=0; chs(&a[6],&x); chs(&a[19],&y);
  rad_xy(a8[6],a8[7],x,y,&z,&r,1,0);
  if(z<10. || z>=n1-10)goto l30;
  if(r<10. || r>=n2-10)goto l30;
  ux[nu]=z; uy[nu]=r;  if(++nu<n-1)goto l30;
l40:
  fclose(fp); printf("readin UCAC4 star: %d\n",nu);

  m=0;
  for(i=0;i<nu;i++){ w[i]=0; r=r0;
    for(j=0;j<nb;j++){
      x=bx[j]-ux[i]; y=by[j]-uy[i];
      z=x*x+y*y; if(z<r){ k=j; r=z; }
    }
    if(r0!=r){ m++; vx[i]=(bx[k]-ux[i])*scale; 
                    vy[i]=(by[k]-uy[i])*scale; w[i]=1; }
  }
  printf("position_matched_star: %d in 1.1 arcsec\n",m);

int i0,i1,i2,i3,i21;
float ss[2],tt[2];
char c34=34;
  i0=0; i1=1; i2=2; i3=3; i21=21;
  pgbegin_(&i0,"/xw",&i1,&i1,3);
  x1=610., x2=600.;              pgpap_(&x1,&x2);
  sprintf(t,"%s",f1);
  if(ac>2){  strcpy(f1,"X  (pixel)");
    x1=x3=0.; x2=n1; x4=n2;  pgenv_(&x1,&x2,&x3,&x4,&i0,&i0);
    for(j=0;j<nu;j++)if(w[j]){ 
      x3=ux[j]; x4=uy[j]; pgsci_(&i2); pgpoint_(&i1,&x3,&x4,&i21);
      ss[0]=x3; tt[0]=x4; ss[1]=vx[j]*400+x3; tt[1]=vy[j]*400+x4;
      pgsci_(&i1); pgline_(&i2,ss,tt); 
    }
  } else {  strcpy(f1,"R.A.  (arcsec)");
    x1=x3=-0.5; x2=x4=0.5;  pgenv_(&x1,&x2,&x3,&x4,&i0,&i0);
    for(j=0;j<nu;j++)if(w[j]){
      if(w[j]==2)pgsci_(&i3); else pgsci_(&i1);
      pgpoint_(&i1,&vx[j],&vy[j],&i1);
    }
    avsig(vx,w,nu,&x1,&x2,&j);
    avsig(vy,w,nu,&x3,&x4,&k);
    printf("After 3 sigma delete\n");
    pgsci_(&i3);
    sprintf(a,"R.A. shift %6.2f%c   rms: %4.2f (%d/%d)",x1,c34,x2,j,m);
    x5=-0.4; x6=0.40; pgtext_(&x5,&x6,a,strlen(a));  printf("%s\n",a);
    sprintf(a,"Dec. shift %6.2f%c   rms: %4.2f (%d/%d)",x3,c34,x4,k,m);
             x6=0.34; pgtext_(&x5,&x6,a,strlen(a));  printf("%s\n",a);
  } pgsci_(&i1);
  pglabel_(f1,"Dec. (UBAND - UCAC4)",t,strlen(f1),20,strlen(t));
  pgend_();    
} 

avsig(v,w,m,a,s,mm)
float *v,*a,*s; int m,*w,*mm;
{
  int i,j,k; float x,xx,aa,ss;
  for(i=0;i<m;i++)if(w[i])w[i]=2;
l10:
  x=0.; for(i=k=0;i<m;i++)if(w[i]==2){ x+=v[i]; k++; } aa=x/k;
  xx=0.; for(i=0;i<m;i++)if(w[i]==2)xx+=(v[i]-aa)*(v[i]-aa); ss=sqrt(xx/k);
  for(i=j=0;i<m;i++)if(w[i]==2){
    x=v[i]-aa; if(x<0.)x=-x; if(x>ss*3.){ w[i]=-1; j++; }
  } if(j)goto l10;
  *mm=k; *a=aa; *s=ss;
}

xytoad(x,a)
double *x,*a;
{
  double z;
  z=x[0]*x[3]-x[2]*x[1];
  a[0]= x[3]/z;
  a[1]=-x[1]/z;
  a[2]=-x[2]/z;
  a[3]= x[0]/z;
  a[4]= (x[2]*x[5]-x[4]*x[3])/z;
  a[5]= (x[4]*x[1]-x[0]*x[5])/z;
}

toms2(aa,c,k)
double aa;           // input
char c[14];          // output
int k;               // input
/*
 hour or degree to char_line
 if k=1 (hour case) in **:**:**.***
    k=0 (degree       -**:**:**.**
*/
{
  int  i,j;
  double a,b,x;
  a=aa;
  if(k==1){ if(a>24.)a-=24.; if(a<0.)a+=24.; }
  c[0]=32; if(a<0.){ a=-a; c[0]='-'; }
  i=a; b=(a-i)*60.;
  j=b; x=(b-j)*60.;
  if(j==60){ j=0; i++; }
  if(k==1)sprintf(&c[1],"%2.2d:%2.2d:%6.3f",i,j,x);
  if(k==0)sprintf(&c[1],"%2.2d:%2.2d:%5.2f",i,j,x);
  if(c[7]==32)c[7]='0';   if(c[8]==32)c[8]='0';
  if(c[7]=='6'){
    c[7]='0'; j++; sprintf(&c[4],"%2.2d",j);
    if(c[4]=='6'){
      c[4]='0'; i++; sprintf(&c[1],"%2.2d",i);
    }
    c[3]=':'; c[6]=':';
  }
}

rad_xy(ac,dc,ra,de,x,y,type,k)
double ac,dc,ra,de,*x,*y;  int type,k;
{
  double xi,xn, u,rar,der;
double tmp;
  rar=ra*cx; der=de*cy;
  u=atan(tan(der)/cos(rar-ac));
  xi=cos(u)*tan(rar-ac)/cos(u-dc);
  xn=tan(u-dc);
  if(type==1){     // schmidt TELESCOPE
    u=sqrt(xi*xi+xn*xn);
    if(u!=0.){ u=atan(u)/u; xi*=u; xn*=u; }
  }
  if(type==2){    //  BOK telescope
    tmp=1.+bok*(xi*xi+xn*xn);
    xi*=tmp; xn*=tmp;
  }
  if(k==0){
    *x=b8[0]*xi+b8[2]*xn+b8[4];
    *y=b8[1]*xi+b8[3]*xn+b8[5];
  }
  if(k==1){ *x=xi; *y=xn;}
}

chs(a,y)
char *a; double *y;
{
  double x;
  char b[20];
  int i,j,k;
  strcpy(b,a); k=strlen(b);
  j=1; for(i=0;i<k;i++){ if(b[i]==32)continue; if(b[i]=='-')j=-1; break; }
  for(i=0;i<k;i++)if(b[i]<'.' || b[i]> '9')b[i]=32;
  i=k=0; x=0.; sscanf(b,"%d %d %lf",&i,&k,&x);
  x=k/60.+x/3600.+i;
  *y=x*j;
}
